unit NoiseUnit;

interface

uses
  Windows, SysUtils, Classes, Graphics, ExtCtrls;
const
  { Free`() 葱 Fill p[^Ɏw肷l(or B) }
  fillBrush  = 1; //  Image.Canvas.Brush œhԂB
  fillCloud  = 2; //  _œhԂB
  fillBorder = 4; // EhԂB

var
  { SʓIȃO[oϐ }
  pVersion: Integer = 2002; // gpp[mCỸo[W (2002 or 1985)
  pUpper: Double = 1.0; // noise() ֐̖߂lۂ̓̏l
  pLower: Double = 0.0; // noise() ֐̖߂lۂ̓̉l
  pStep: Integer = 2; // ExistColor() ŐFT̃Xebv(1 ` 16 sNZ)
  pNon: Integer = 4; // NonExistColor() ő݂ȂFT̉(2 ` 64 )
  fStep: Integer = 1; // Free`() 葱Ő̃Xebv(1 ` 4 sNZ)
  fCorr: Integer = 10; // FreeLine() ̗[X[YɂȂlɒ鎞̗[̋(5 ` 20 sNZ)
  gColors: array[0..255] of TColor; // Of[VJ[

 {_`ꍇApStep ̒l傫ق ExistColor(), NonExistColor(),
    FreePolygon(), FreeRectangle(), FreeEllipse() ̑x͑Ȃ܂A
    ʂ̐M͏XɒႢ̂ƂȂ܂BԂ͂܂ pStep = 1
    ̏ꍇłM̂ƂȂ܂B

  _`ꍇApNon ̒l܂菬ƕ`Ɏs\
    Ȃ܂B4 ` 8 ʂKł傤B}

  { Perlin Noise 1985 Version ֘ÃO[oϐ }
  pStart: Integer = 1; // pPerlin() ̏I 0 ɂȂϐ
  pDimension: Integer = 3; // pPerlin() gp鎟߂ϐ (1 ` 3)
  pp: array[0..513] of Integer;
  g3: array[0..513, 0..2] of Double;
  g2: array[0..513, 0..1] of Double;
  g1: array[0..513] of Double;

function pPerlin(x, y, z: Double): Double; // Perlin Noise 1985 Version

function Perlin(x, y, z: Double): Double; // Perlin Noise 2002 Version

function noise(x: Double;
               y: Double = -1.53431; // fBtHgp[^(ȗ)
               z: Double = -1.53431  // fBtHgp[^(ȗ)
               ): Double;

function opnoise(octaves: Integer; // mCY̐
                 persistence: Double; // 邽тɃmCY̐U銄
                 x: Double;
                 y: Double = -1.53431; // fBtHgp[^(ȗ)
                 z: Double = -1.53431  // fBtHgp[^(ȗ)
                 ): Double;

function adjPoints(var LT, RB: TPoint; // `̑Ίp2_
                   adj: Integer // `gEk鎞̒l
                   ): Boolean;

function ExistColor(Image: TImage; // `
                    Color: TColor; // TF
                    LT, RB: TPoint // FT̈̍ƉE̓_
                    ): Boolean;

function NonExistColor(Image: TImage; // `
                       var Color: TColor; // ݂ȂF
                       LT, RB: TPoint // FT̈̍ƉE̓_
                       ): Boolean;

procedure ExceptColor(Image: TImage; // `
                      Color: TColor; // TF
                      LT, RB: TPoint; // FT̈̍ƉE̓_
                      r: Integer = 4 // Cx(1 ` 16)
                      );

function MakeGradation(GridColor: TColor; // \F
                       BackColor: TColor; // wiF
                       N: Integer; // F
                       var Colors: array of TColor // Of[V̐Fi[z
                       ): Integer;

procedure GridDraw(var Image: TImage; // `
                   LT, RB: TPoint; // `͈͂̍ƉE̓_
                   GridSize: Integer; // Obḧӂ̃TCY
                   N: Integer; // F
                   octaves: Integer; // mCY̐
                   persistence: Double; // mCY銄
                   Start: Double; // p[mCỸp[^ x, y ̏l
                   Step: Double; // p[mCỸp[^ x, y ̃Xebvl
                   Colors: array of TColor; // gpFi[z
                   DColor: Integer = -1 // `͈͂ł̐F݂̂̕ɕ`悵܂B
                   );

procedure FreeLine(var Image: TImage; // `
                   P1, P2: TPoint; // Image.Canvas ̕`̎n_ƏI_
                   ANoise: Integer = 5; // mCY̍őUl(sNZ)
                   Scale: Double = 0.03 // WƃmCY֐̃p[^̔{
                   );

procedure FreePolygon(var Image: TImage; // `
                      PP: array of TPoint; // p`̊e_
                      ANoise: Integer = 5; // mCY̍őUl(sNZ)
                      Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                      Fill: Integer = 0 // ̓hԂw肷l
                      );

procedure FreeRectangle(var Image: TImage; // `
                        LT, RB: TPoint; // `̍ƉE̓_
                        ANoise: Integer = 5; // mCY̍őUl(sNZ)
                        Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                        Fill: Integer = 0 // ̓hԂw肷l
                        );

procedure FreeEllipse(var Image: TImage; // `
                      LT, RB: TPoint; // ȉ~̊Oڒ`̍ƉE̓_
                      ANoise: Integer = 5; // mCY̍őUl(sNZ)
                      Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                      Fill: Integer = 0 // ̓hԂw肷l
                      );

implementation

{ ̊֐ Ken Perlin  1985 Nɔ\ C ŏꂽŏ̃mCY }
{ ֐(o[mCY) Delphi  Object Pascal ̃R[hɖ|󂵂̂łB}
{ ̖|ł̒쌠 Ken Perlin 񂪕ێ܂Bo[mCY͎RE }
{ lXȌۂ̗lɃtN^̋KƘA }
{ _ȐԂׂɊJꂽ̂łBʏ̗Ԃ֐Ƃ͑Si }
{ ̈قȂ̂łB߂l -1`1 ̒lłB}

function pPerlin(x, y, z: Double): Double; // Perlin Noise 1985
const
  B = $100;
  BM = $FF;
  N = $1000;
  NP = 12;
  NM = $FFF;

  procedure init;
  var
    i, j, k: Integer;

    procedure normalize2(var a, b: Double);
    var
      s: Double;
    begin
      s := Sqrt(a * a + b * b);
      a := a / s;
      b := b / s;
    end;

    procedure normalize3(var a, b, c: Double);
    var
      s: Double;
    begin
      s := Sqrt(a * a + b * b + c * c);
      a := a / s;
      b := b / s;
      c := c / s;
    end;

  begin
    for i := 0 to B - 1 do
    begin
      pp[i] := i;

      g1[i] := ((random(B + B) mod (B + B)) - B) / B;

      for j := 0 to 1 do
        g2[i][j] := ((random(B + B) mod (B + B)) - B) / B;
      normalize2(g2[i][0], g2[i][1]);

      for j := 0 to 2 do
        g3[i][j] := ((random(B + B) mod (B + B)) - B) / B;
      normalize3(g3[i][0], g3[i][1], g3[i][2]);
    end;

    for i := B - 1 downto 0 do
    begin
      k := pp[i];
      j := random(B + B) mod B;
      pp[i] := pp[j];
      pp[j] := k;
    end;

    for i := 0 to B + 1 do
    begin
      pp[B + i] := pp[i];
      g1[B + i] := g1[i];
      for j := 0 to 1 do
        g2[B + i][j] := g2[i][j];
      for j := 0 to 2 do
        g3[B + i][j] := g3[i][j];
    end;
  end;

  function noise1(x: Double): Double;
  var
    bx0, bx1: Integer;
    rx0, rx1, sx, u, v: Double;

    procedure setup(x: Double; var b0, b1: Integer; var r0, r1: Double);
    var
      t: Double;
    begin
      t := x + N;
      b0 := Trunc(t) and BM;
      b1 := (b0 + 1) and BM;
      r0 := t - Trunc(t);
      r1 := r0 - 1;
    end;

    function s_curve(t: Double): Double;
    begin
      Result := t * t * (3 - 2 * t);
    end;  

    function lerp(t, a, b:Double): Double;
    begin
      Result := a + t * (b - a);
    end;


  begin
    setup(x, bx0, bx1, rx0, rx1);
    sx := s_curve(rx0);
    u := rx0 * g1[pp[bx0]];
    v := rx1 * g1[pp[bx1]];
    Result := lerp(sx, u, v);
  end;

  function noise2(x, y: Double): Double;
  var
    bx0, bx1, by0, by1, b00, b10, b01, b11: Integer;
    rx0, rx1, ry0, ry1, sx, sy, a, b, u, v: Double;
    i, j: Integer;

    procedure setup(x: Double; var b0, b1: Integer; var r0, r1: Double);
    var
      t: Double;
    begin
      t := x + N;
      b0 := Trunc(t) and BM;
      b1 := (b0 + 1) and BM;
      r0 := t - Trunc(t);
      r1 := r0 - 1;
    end;

    function s_curve(t: Double): Double;
    begin
      Result := t * t * (3 - 2 * t);
    end;  

    function at2(a: Integer; rx, ry: Double): Double;
    begin
      Result := rx * g2[a][0] + ry * g2[a][1];
    end;

    function lerp(t, a, b:Double): Double;
    begin
      Result := a + t * (b - a);
    end;

  begin
    setup(x, bx0, bx1, rx0, rx1);
    setup(y, by0, by1, ry0, ry1);

    i := pp[bx0];
    j := pp[bx1];

    b00 := pp[i + by0];
    b10 := pp[j + by0];
    b01 := pp[i + by1];
    b11 := pp[j + by1];

    sx := s_curve(rx0);
    sy := s_curve(ry0);

    u := at2(b00, rx0, ry0);
    v := at2(b10, rx1, ry0);
    a := lerp(sx, u, v);

    u := at2(b01, rx0,ry1);
    v := at2(b11, rx1,ry1);
    b := lerp(sx, u, v);

    Result := lerp(sy, a, b);
  end;

  function noise3(x, y, z:Double): Double;
  var
    bx0, bx1, by0, by1, bz0, bz1, b00, b10, b01, b11: Integer;
    rx0, rx1, ry0, ry1, rz0, rz1, sy, sz, a, b, c, d, t, u, v: Double;
    i, j: Integer;

    procedure setup(x: Double; var b0, b1: Integer; var r0, r1: Double);
    var
      t: Double;
    begin
      t := x + N;
      b0 := Trunc(t) and BM;
      b1 := (b0 + 1) and BM;
      r0 := t - Trunc(t);
      r1 := r0 - 1;
    end;

    function s_curve(t: Double): Double;
    begin
      Result := t * t * (3 - 2 * t);
    end;  

    function at3(a: Integer; rx, ry, rz: Double): Double;
    begin
      Result := rx * g3[a][0] + ry * g3[a][1] + rz * g3[a][2];
    end;

    function lerp(t, a, b:Double): Double;
    begin
      Result := a + t * (b - a);
    end;

  begin
    setup(x, bx0, bx1, rx0, rx1);
    setup(y, by0, by1, ry0, ry1);
    setup(z, bz0, bz1, rz0, rz1);

    i := pp[bx0];
    j := pp[bx1];

    b00 := pp[i + by0];
    b10 := pp[j + by0];
    b01 := pp[i + by1];
    b11 := pp[j + by1];

    t  := s_curve(rx0);
    sy := s_curve(ry0);
    sz := s_curve(rz0);

    u := at3(b00 + bz0, rx0, ry0, rz0);
    v := at3(b10 + bz0, rx1, ry0, rz0);
    a := lerp(t, u, v);

    u := at3(b01 + bz0, rx0, ry1, rz0);
    v := at3(b11 + bz0, rx1, ry1, rz0);
    b := lerp(t, u, v);

    c := lerp(sy, a, b);

    u := at3(b00 + bz1, rx0, ry0, rz1);
    v := at3(b10 + bz1, rx1, ry0, rz1);
    a := lerp(t, u, v);

    u := at3(b01 + bz1, rx0, ry1, rz1);
    v := at3(b11 + bz1, rx1, ry1, rz1);
    b := lerp(t, u, v);

    d := lerp(sy, a, b);

    Result := lerp(sz, c, d);
  end;

begin
  if pStart = 1 then
  begin
    pStart := 0;
    init;
  end;

  case pDimension of // O[oϐ
    3: Result := noise3(x, y, z);
    2: Result := noise2(x, y);
  else
    Result := noise1(x);
  end;
end;

{ ̊֐ Ken Perlin  2002 Nɔ\ Java ŏꂽmCY֐ }
{ (o[mCY) Delphi  Object Pascal ̃R[hɖ|󂵂̂łB}
{ ̖|ł̒쌠 Ken Perlin 񂪕ێ܂Bo[mCY͎RE }
{ ɂlXȌۂ̗lɃtN^̋KƘA }
{ _ȐԂׂɊJꂽ̂łBʏ̗Ԃ֐Ƃ͑S }
{ ïقȂ̂łB߂l -1`1 ̒lłBŏ̃o[mCY }
{ 1985 N ɔ\܂A2002 Nɂ̉ǔł\܂B}

function Perlin(x, y, z: Double): Double;
const
  p: array[0..255] of byte = (
    151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225,
    140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23, 190, 6, 148,
    247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32,
    57, 177, 33, 88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175,
    74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83, 111, 229, 122,
    60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54,
    65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169,
    200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64,
    52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212,
    207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42, 223, 183, 170, 213,
    119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9,
    129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104,
    218, 246, 97, 228, 251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241,
    81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157,
    184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93,
    222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180
    );

var
  a, b, c, A0, A1, A2, B0, B1, B2: Integer;
  u, v, w: Double;

  function fade(t: Double): Double;
  begin
    Result := ((t * 6 - 15) * t + 10) * t * t * t;
  end;

  function lerp(t, a, b:Double): Double;
  begin
    Result := t * (b - a) + a;
  end;

  function grad(hash: Integer; x, y, z: Double): Double;
  var
    h: Integer;
    u, v: Double;
  begin
    h := hash and 15;    // CONVERT LO 4 BITS OF HASH CODE
    if h < 8 then u := x // INTO 12 GRADIENT DIRECTIONS.
    else u := y;
    if h < 4 then v := y
    else
    begin
      if h in [12, 14] then v := x
      else v := z;
    end;
    if h and 1 = 0 then Result := u
    else Result := -u;
    if h and 2 = 0 then Result := Result + v
    else Result := Result - v;
  end;

begin
  a := Trunc(x) and 255; // FIND UNIT CUBE THAT
  b := Trunc(y) and 255; // CONTAINS POINT.
  c := Trunc(z) and 255;
  x := Frac(x);          // FIND RELATIVE a, b, c
  y := Frac(y);          // OF POINT IN CUBE.
  z := Frac(z);
  u := fade(x);          // COMPUTE FADE CURVES
  v := fade(y);          // FOR EACH OF a, b, c
  w := fade(z);

  A0 := p[a and 255] + b;        // HASH COORDINATES OF
  A1 := p[A0 and 255] + c;       // THE 8 CUBE CORNERS
  A2 := p[(A0 + 1) and 255] + c;
  B0 := p[(a + 1) and 255] + b;
  B1 := p[B0 and 255] + c;
  B2 := p[(B0 + 1) and 255] + c;

  Result := lerp(w, lerp(v, lerp(u, grad(p[A1 and 255], x, y, z),                // AND ADD
                                    grad(p[B1 and 255], x - 1, y, z)),           // BLENDED
                            lerp(u, grad(p[A2 and 255], x, y - 1, z),            // RESULTS
                                    grad(p[B2 and 255], x - 1, y - 1, z))),      // FROM  8
                    lerp(v, lerp(u, grad(p[(A1 + 1) and 255], x, y, z - 1),      // CORNERS
                                    grad(p[(B1 + 1) and 255], x - 1, y, z - 1)), // OF CUBE
                            lerp(u, grad(p[(A2 + 1) and 255], x, y - 1, z - 1),
                                    grad(p[(B2 + 1) and 255], x - 1, y - 1, z - 1))));
end;

{ ̊֐͏q Perlin()  pPerlin() ֐gp 0`1 ̒l̃mCY }
{ Ԃlɂ̂łB܂ 0 <= pLower < pUpper <= 1 Ƃ𖞂 }
{ O[oϐ̒l𒲐邱Ƃɂčŏɓꂽl pLower`pUpper }
{ ̕ 0`1 ̒lɊg()鎖o܂B̊֐̑2A3p }
{ [^ y, z ̓fBtHglw肵fBtHgp[^ƂĒ` }
{ Ă܂̂łȗ鎖\łBȂ킿 }
{ noise(x); }
{ noise(x, y); }
{ noise(x, y, z); }
{ ̗l 1A2A3̍Wn֐̗lɈ\łB}

function noise(x: Double;
               y: Double = -1.53431; // fBtHgp[^(ȗ)
               z: Double = -1.53431  // fBtHgp[^(ȗ) 
               ): Double;
begin
  if pLower < 0 then pLower := 0;
  if pUpper > 1 then pUpper := 1;
  if pLower >= pUpper then
  begin
    pLower := 0; // fBtHgl
    pUpper := 1; // fBtHgl
  end;

  if pVersion = 2002 then // Perlin Noise 2002 Version
  begin
    if x < 0 then x := -x; // ̒lɂB
    if y < 0 then y := -y; // ̒lɂB
    if z < 0 then z := -z; // ̒lɂB
  end;

  if pVersion = 2002 then // Perlin Noise 2002 Version
    Result := (Perlin(x, y, z) + 1) / 2 // 0`1 ̒lɂB
  else // Perlin Noise 1985 Version
    Result := (pPerlin(x, y, z) + 1) / 2; // 0`1 ̒lɂB
  Result := (Result - pLower) / (pUpper - pLower); // pLower`pUpper ̒l 0`1 ̒lɊg(Expand)B 
  if Result < 0 then Result := 0;
  if Result > 1 then Result := 1;
end;

{ ̊֐͏q noise() ֐gp octaves ̃mCYĂ̒l }
{ Ԃ֐łBmCY邽тɃmCY̐U persistence {Â }
{ čs܂B1 <= octaves <= 32, 0 <= persistence <= 1 łȂ΂Ȃ }
{ ܂B߂l 0`1 ̒lɂȂlɒĂ܂B܂Å֐̑4A}
{ 5p[^ y, z ̓fBtHglw肵fBtHgp[^Ƃ }
{ `Ă܂̂łȗ鎖\łBȂ킿A}
{ opnoise(octaves, persistence, x); }
{ opnoise(octaves, persistence, x, y); }
{ opnoise(octaves, persistence, x, y, z); }
{ ̗l 1A2A3̍Wn֐̗lɈ\łB}

function opnoise(octaves: Integer; // mCY̐
                 persistence: Double; // 邽тɃmCY̐U銄
                 x: Double;
                 y: Double = -1.53431; // fBtHgp[^(ȗ)
                 z: Double = -1.53431  // fBtHgp[^(ȗ)
                 ): Double;
var
  i, frequency: Integer;
  total, amplitude, maxvalue: Double;
begin
  if octaves < 1 then octaves := 1
  else if octaves > 32 then octaves := 32;
  if persistence < 0 then persistence := 0
  else if persistence > 1 then persistence := 1;

  total := 0; // vl
  frequency := 1; // g
  amplitude := 1; // U
  maxvalue := 0; // ől

  for i := 0 to octaves - 1 do
  begin
    total := total + noise(x * frequency, y * frequency, z * frequency) * amplitude;
    maxvalue := maxvalue + amplitude;
    amplitude := amplitude * persistence;
    frequency := frequency * 2;
  end;

  Result := total / maxvalue;
end; 

{ ̊֐ 2_ LT, RB ΊpƂ钷`̍̓_̍W LT ɁA}
{ E̓_̍W RB ɐݒ肵A`̎ӂ adj sNZ }
{ Âg傠邢͏k֐łB(adj }CiX̎͏kłB) }
{ gEkɐ True Ԃ܂B}

function adjPoints(var LT, RB: TPoint; // `̑Ίp2_
                   adj: Integer // `gEk鎞̒l
                   ): Boolean;
var
  lx, ly, rx, ry: Integer;
begin
  Result := True;

  if LT.X < RB.X then
  begin
    lx := LT.X; rx := RB.X;
  end
  else
  begin
    lx := RB.X; rx := LT.X;
  end;

  if LT.Y < RB.Y then
  begin
    ly := LT.Y; ry := RB.Y;
  end
  else
  begin
    ly := RB.Y; ry := LT.Y;
  end;

  if ((rx + adj) - (lx - adj) < 0) or
     ((ry + adj) - (ly - adj) < 0) then
    Result := False
  else
  begin
    LT := Point(lx - adj, ly - adj);
    RB := Point(rx + adj, ry + adj);
  end;
end;

{ ̊֐͗̈ Color ݂ True Ԃ֐łB}

function ExistColor(Image: TImage; // `
                    Color: TColor; // TF
                    LT, RB: TPoint // FT̈̍ƉE̓_
                    ): Boolean;
var
  i, x, y, Count: Integer;
begin
  Result := False;
  if pStep < 1 then pStep := 1;
  if pStep > 16 then pStep := 16;
  adjPoints(LT, RB, 0); // LT, RB 𐳋KB

  i := 0;
  Count := (RB.X - LT.X + 1) * (RB.Y - LT.Y + 1); 
  while i < Count do
  begin
    y := i div (RB.X - LT.X + 1);
    x := i mod (RB.X - LT.X + 1);
    if Image.Canvas.Pixels[x, y] = Color then
    begin
      Result := True;
      Break;
    end;
    i := i + pStep;
  end;
end;

{ ̊֐͗̈ɑ݂ȂFTA΂̐F Color Ɋi[ }
{ True Ԃ֐łB}

function NonExistColor(Image: TImage; // `
                       var Color: TColor; // ݂ȂF
                       LT, RB: TPoint // FT̈̍ƉE̓_
                       ): Boolean;
var
  i, Col: Integer;
begin
  Result := False;
  adjPoints(LT, RB, 0); // LT, RB 𐳋KB
  if pNon < 2 then pNon := 2;
  if pNon > 64 then pNon := 64;
  Col := Integer(Color); // p[^ŗ^ꂽFŏɒTB
  
  i := 0;
  repeat
    if not ExistColor(Image, TColor(Col), LT, RB) then
    begin
      Result := True;
      Color := TColor(Col);
    end;
    Inc(i); Inc(Col);
    if Col > $FFFFFF then Col := 0;
  until (Result = True) or (i >= pNon); // ő Non TB    
end;

{ ̎葱͗̈ Color ̐F̕΁A𑼂̐Fɒu }
{ ڗȂ葱łBLT  RB ͗̈撷`̍ƉE̓_łB }
{ r ͏Cx 1 ` 16 ̒lw肵ĉBr ̒l傫قǑ }
{ ł܂̃x͉܂Br ̒lقǏ̃x }
{ オ܂x͂lɂȂ܂B}

procedure ExceptColor(Image: TImage; // `
                      Color: TColor; // TF
                      LT, RB: TPoint; // FT̈̍ƉE̓_
                      r: Integer = 4 // Cx(1 ` 16)
                      );
var
  x, y, hh, ww: Integer;
  C, D: TPoint;
  Col: TColor; // ݂̐F
  RCol: TColor; // uF
begin
  if r < 1 then r := 1
  else if r > 16 then r := 16;
  adjPoints(LT, RB, 0); // LT, RB 𐳋KB
  if r = 1 then // łCxꍇ
  begin
    hh := (RB.Y - LT.Y + 1) div 4; // ㉺̏C̏c̃TCY
    ww := (RB.X - LT.X + 1) div 2; // ȄC̉̃TCY
    C := Point(LT.X + ww - 1, LT.Y + hh);
    D := Point(RB.X - ww + 1, RB.Y - hh);
  end
  else
  begin
    hh := (RB.Y - LT.Y + 1) div r; // ㉺̏C̏c̃TCY
    ww := (RB.X - LT.X + 1) div r; // ȄC̉̃TCY
    C := Point(LT.X + ww - 1, LT.Y + hh);
    D := Point(RB.X - ww + 1, RB.Y - hh);
  end;
  RCol := Image.Canvas.Pixels[C.X + 1, C.Y];
  if RCol = Color then RCol := (not Color) and $FFFFFF;

  { ʂƉEʂ̏C }
  if r <> 2 then
  begin
    for y := C.Y to D.Y do
    begin
      for x := C.X downto LT.X do
      begin
        Col := Image.Canvas.Pixels[x, y];
        if Col = Color then
          Image.Canvas.Pixels[x, y] := RCol
        else
          RCol := Col;
      end;
      RCol := Image.Canvas.Pixels[C.X, y];
    end;
    for y := C.Y to D.Y do
    begin
      for x := D.X to RB.X do
      begin
        Col := Image.Canvas.Pixels[x, y];
        if Col = Color then
          Image.Canvas.Pixels[x, y] := RCol
        else
          RCol := Col;
      end;
      RCol := Image.Canvas.Pixels[D.X, y];
    end;
  end;

  { ʂƉʂ̏C }
  for x := LT.X to RB.X do
  begin
    RCol := Image.Canvas.Pixels[x, C.Y];
    for y := C.Y - 1 downto LT.Y do
    begin
      Col := Image.Canvas.Pixels[x, y];
      if Col = Color then
        Image.Canvas.Pixels[x, y] := RCol
      else
        RCol := Col;
    end;
  end;
  for x := LT.X to RB.X do
  begin
    RCol := Image.Canvas.Pixels[x, D.Y];
    for y := D.Y + 1 to RB.Y do
    begin
      Col := Image.Canvas.Pixels[x, y];
      if Col = Color then
        Image.Canvas.Pixels[x, y] := RCol
      else
        RCol := Col;
    end;
  end;
end;

{ ̊֐́A\F(GridColor) ̓x(0`255)ωĕ\F(GridColor) }
{ wiF(BackColor) ܂ N K̃Of[VF쐬Ĕz Colors  }
{ i[֐łB2 <= N <= 256, N <= Length(Colors) łȂ΂Ȃ܂B}
{ ߂l͎ۂɍ쐬Of[VF̐łB}

function MakeGradation(GridColor: TColor; // \F
                       BackColor: TColor; // wiF
                       N: Integer; // F
                       var Colors: array of TColor // Of[V̐Fi[z
                       ): Integer;
var
  i, X, Step, Col: Integer;
  gB, gG, gR: Integer;
  bB, bG, bR: Integer;
begin
  Result := 0;
  if (N < 2) or (N > 256) or (Length(Colors) < N) then Exit;
  Result := N;

  gB := (GridColor shr 16) and $FF;
  gG := (GridColor shr 8) and $FF;
  gR := GridColor and $FF;

  bB := (BackColor shr 16) and $FF;
  bG := (BackColor shr 8) and $FF;
  bR := BackColor and $FF;

  X := 0;
  Step := 255 div (N - 1);
  for i := 0 to N - 1 do
  begin
    if i = N - 1 then X := 255;
    Col := Round(X * (bB - gB) / 255 + gB) shl 16;
    Col := Col or (Round(X * (bG - gG) / 255 + gG) shl 8);
    Col := Col or Round(X * (bR - gR) / 255 + gR);
    Colors[i] := TColor(Col);
    X := X + Step;
  end;
end;

{ ̎葱́AImage ̃LoXɃObhzuāAopnoise() ֐Ŋe }
{ Obh̐F߂ĕ`悷葱łBObhƂ́ALoXᎆ }
{ lɊiqɕ\Ӗ܂BLT, RB ̓LoX̕`͈͂̍ }
{ E̓_AGridSize ̓Obḧӂ̃TCYAN ͎gpFłBoctaves }
{ ͍mCY̐Apersistence ͍邽тɃmCY銄ŁA}
{ ꂼ opnoise() ֐Ɏw肷p[^łBStart  opnoise() ֐ }
{ p[^ x, y ̏lAStep  x, y ̃XebvlAColors ͎gpF }
{ i[złBGridDraw() ͕`͈͂ŐF DColor ݂̂̕ɕ`悵܂ }
{ ADColor = -1 ̂Ƃ͕`͈͑Sɕ`悵܂B1 <= GridSize <= 64, }
{ 2 <= N <= 256, 1 <= octaves <= 32, 0 <= persistence <= 1, 0 < Step, }
{ N <= Length(Colors) łȂ΂Ȃ܂B}

procedure GridDraw(var Image: TImage; // `
                   LT, RB: TPoint; // `͈͂̍ƉE̓_
                   GridSize: Integer; // Obḧӂ̃TCY
                   N: Integer; // F
                   octaves: Integer; // mCY̐
                   persistence: Double; // mCY銄
                   Start: Double; // p[mCỸp[^ x, y ̏l
                   Step: Double; // p[mCỸp[^ x, y ̃Xebvl
                   Colors: array of TColor; // gpFi[z
                   DColor: Integer = -1 // `͈͂ł̐F݂̂̕ɕ`悵܂B
                   );
var
  gx, gy, i, row, col: Integer;
  LX, LY, RX, RY: Integer;
  x, y: Double;
begin
  if (GridSize < 1) or (GridSize > 64) or (N < 2) or (N > 256) or
     (Step <= 0) or (Length(Colors) < N) then
    Exit;

  adjPoints(LT, RB, 0); // LT, RB 𐳋KB
  row := (RB.Y - LT.Y + 1) div GridSize;
  if (RB.Y - LT.Y + 1) mod GridSize <> 0 then Inc(row);
  col := (RB.X - LT.X + 1) div GridSize;
  if (RB.X - LT.X + 1) mod GridSize <> 0 then Inc(col);

  y := Start;
  for gy := 0 to row - 1 do
  begin
    x := Start;
    for gx := 0 to col - 1 do
    begin
      LX := LT.X + gx * GridSize;
      LY := LT.Y + gy * GridSize;
      RX := LX + GridSize;
      if RX > RB.X + 1 then RX := RB.X + 1;
      RY := LY + GridSize;
      if RY > RB.Y + 1 then RY := RB.Y + 1;
      if (DColor = -1) or
         ((Image.Canvas.Pixels[LX, LY] = TColor(DColor)) and
          (Image.Canvas.Pixels[RX - 1, RY - 1] = TColor(DColor))) then
      begin
        i := Round(opnoise(octaves, persistence, x, y) * (N - 1));
        if GridSize = 1 then
          Image.Canvas.Pixels[LX, LY] := Colors[i]
        else
        begin
          Image.Canvas.Brush.Color := Colors[i];
          Image.Canvas.FillRect(Rect(LX, LY, RX, RY));
        end;
      end;
      x := x + Step;
    end;
    y := y + Step;
  end;
end;

{ ̎葱́AImage ̃LoX̂Q_ԂɃt[nhŕ`lȐ }
{ 葱łBP1, P2 ͕`̎n_ƏI_łBANoise ̓mCY̍őUlA}
{ Scale ͉ʂ̍WƃmCỸp[^̔{łB̊֐ ANoise  Scale }
{ p[^̓fBtHglw肵fBtHgp[^ƂĒ` }
{ ܂̂łȗ鎖\łBȂ킿 }
{ FreeLine(Image, P1, P2); }
{ FreeLine(Image, P1, P2, ANoise); }
{ FreeLine(Image, P1, P2, ANoise, Scale); }
{ ̗lɋLq鎖\łB}

procedure FreeLine(var Image: TImage; // `
                   P1, P2: TPoint; // Image.Canvas ̕`̎n_ƏI_
                   ANoise: Integer = 5; // mCY̍őUl(sNZ)
                   Scale: Double = 0.03 // ʂ̍WƃmCỸp[^̔{
                   );
var
  a, b, c, d: Double;
  x, y: Integer;
  Q1, Q2: TPoint;
begin
  if (P1.X = P2.X) and (P1.Y = P2.Y) then
    Exit;
  Q1 := P1; Q2 := P2;

  if fStep < 1 then fStep := 1;
  if fStep > 4 then fStep := 4;
  if fCorr < 5 then fCorr := 5;
  if fCorr > 20 then fCorr := 20;

  if Abs(P2.Y - P1.Y) < Abs(P2.X - P1.X) then // a < 1 ̎
  begin //  y = ax + b  x ̒lωB
    if P2.X < P1.X then
    begin
      Q1 := P2; Q2 := P1;
    end;

    a := (Q2.Y - Q1.Y) / (Q2.X - Q1.X);
    b := Q2.Y - a * Q2.X;
    x := Q1.X; y := Q1.Y;
    Image.Canvas.MoveTo(x, y);
    x := x + fCorr;

    repeat
      if x >= Q2.X - fCorr then
      begin
        x := Q2.X; y := Q2.Y;
      end
      else
        y := Round(a * x + b + noise(Scale * x) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
      x := x + fStep;
    until x >= Q2.X;
  end
  else // a >= 1 ̎
  begin //  x = cy + d  y ̒lωB
    if  P2.Y < P1.Y then
    begin
      Q1 := P2; Q2 := P1;
    end;

    c := (Q2.X - Q1.X) / (Q2.Y - Q1.Y);
    d := Q2.X - c * Q2.Y;
    y := Q1.Y; x := Q1.X;
    Image.Canvas.MoveTo(x, y);
    y := y + fCorr;

    repeat
      if y >= Q2.Y - fCorr then
      begin
        y := Q2.Y; x := Q2.X;
      end
      else
        x := Round(c * y + d + noise(Scale * y) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
      y := y + fStep;
    until y >= Q2.Y;
  end;
end;

{ ̎葱́AImage ̃LoXɃt[nhŕ`lȕp` }
{ `葱łBPP  p`̊e_̔złBANoise ̓mCY̍őUl }
{ Scale ͉ʂ̍WƃmCỸp[^̔{łBFill ͓̓hԂ }
{ w肷lŁÃt@C̐擪ɐ܂B̊֐ ANoise  }
{ Scale  Fill p[^̓fBtHglw肵fBtHgp[^ }
{ Ē`Ă܂̂łȗ鎖\łBȂ킿 }
{ FreePolygon(Image, PP); }
{ FreePolygon(Image, PP, ANoise); }
{ FreePolygon(Image, PP, ANoise, Scale); }
{ FreePolygon(Image, PP, ANoise, Scale, Fill); }
{ ̗lɋLq鎖\łB}

procedure FreePolygon(var Image: TImage; // `
                      PP: array of TPoint; // p`̊e_
                      ANoise: Integer = 5; // mCY̍őUl(sNZ)
                      Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                      Fill: Integer = 0  // ̓hԂw肷l
                      );
var
  i, n, x, y: Integer;
  Col, PenCol, BrushCol: TColor;
  LT, RB: TPoint;
begin
  n := Length(PP);
  if n < 2 then
    Exit;

  LT := PP[0]; RB := PP[n - 1];
  i := 0; x := 0; y := 0;
  repeat
    x := x + PP[i].X; y := y + PP[i].Y;
    if PP[i].X < LT.X then LT.X := PP[i].X;
    if PP[i].Y < LT.Y then LT.Y := PP[i].Y;
    if PP[i].X > RB.X then RB.X := PP[i].X;
    if PP[i].Y > RB.Y then RB.Y := PP[i].Y;
    Inc(i);
  until i = n;
  x := x div n; y := y div n; // S_
  adjPoints(LT, RB, ANoise); // LT, RB 𐳋KB

  PenCol := Image.Canvas.Pen.Color;
  BrushCol := Image.Canvas.Brush.Color;
  if (Fill and (fillBrush or fillCloud)) <> 0 then // hԂꍇ
  begin
    Col := PenCol;
    if NonExistColor(Image, Col, LT, RB) then
      Image.Canvas.Pen.Color := Col; // Col ͗̈ɑ݂ȂF
  end;

  i := 0;
  repeat
    FreeLine(Image, PP[i], PP[i + 1], ANoise, Scale);
    Inc(i);
  until i = n - 1;
  if n > 2 then
    FreeLine(Image, PP[i], PP[0], ANoise, Scale);

  if (Fill and (fillBrush or fillCloud)) <> 0 then // hԂꍇ
  begin
    if (Fill and fillBrush) <> 0 then
    begin
      Image.Canvas.FloodFill(x, y, Col, fsBorder); //  BrushCol œhԂ
      if ((Fill and fillBorder) = 0) and (Col <> PenCol) then
      begin
        Image.Canvas.Pen.Color := PenCol;
        FreePolygon(Image, PP, ANoise, Scale, 0); // E`
      end;
      if ((Fill and fillBorder) <> 0) and (Col <> BrushCol) then
      begin
        Image.Canvas.Pen.Color := BrushCol;
        FreePolygon(Image, PP, ANoise, Scale, 0); // E`
      end;
    end
    else if (Fill and fillCloud) <> 0 then
    begin
      Image.Canvas.Brush.Color := Col;
      Image.Canvas.FloodFill(x, y, Col, fsBorder); //  Col œhԂ
      if MakeGradation(clWhite, clBlue, 128, gColors) = 128 then
        GridDraw(Image, LT, RB, 3, 128, 3, 0.5, 0, 0.03, gColors, Integer(Col));
      if (Fill and fillBorder) = 0 then
      begin
        Image.Canvas.Pen.Color := PenCol;
        FreePolygon(Image, PP, ANoise, Scale, 0); // E`
      end
      else
        ExceptColor(Image, Col, LT, RB);
    end;
    Image.Canvas.Pen.Color := PenCol;
    Image.Canvas.Brush.Color := BrushCol;
  end;
end;

{ ̎葱́AImage ̃LoXɃt[nhŕ`lȒ`` }
{ 葱łBLT  `̍̓_ARB  `̉E̓_łBANoise  }
{ mCY̍őUlAScale ͉ʂ̍WƃmCỸp[^̔{łB}
{ Fill ͓̓hԂw肷lŁÃt@C̐擪ɐ }
{ ܂B̊֐ ANoise  Scale  Fill p[^̓fBtHglw }
{ fBtHgp[^ƂĒ`Ă܂̂łȗ鎖 }
{ \łBȂ킿 }
{ FreeRectangle(Image, LT, RB); }
{ FreeRectangle(Image, LT, RB, ANoise); }
{ FreeRectangle(Image, LT, RB, ANoise, Scale); }
{ FreeRectangle(Image, LT, RB, ANoise, Scale, Fill); }
{ ̗lɋLq鎖\łB}

procedure FreeRectangle(var Image: TImage; // `
                        LT, RB: TPoint; // `̍ƉE̓_
                        ANoise: Integer = 5; // mCY̍őUl(sNZ)
                        Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                        Fill: Integer = 0  // ̓hԂw肷l
                        );
var
  RT, LB: TPoint;
begin
  RT := Point(RB.X, LT.Y);
  LB := Point(LT.X, RB.Y);
  FreePolygon(Image, [LT, RT, RB, LB], ANoise, Scale, Fill);
end;

{ ̎葱́AImage ̃LoXɃt[nhŕ`lȑȉ~`葱 }
{ łBLT  RB ͑ȉ~̊Oڒ`̍ƉE̓_łBANoise ̓mCY }
{ őUlAScale ͉ʂ̍WƃmCỸp[^̔{łBFill ͓ }
{ ̓hԂw肷lŁÃt@C̐擪ɐ܂B̊֐ }
{  ANoise  Scale  Fill p[^̓fBtHglw肵fBtHg }
{ p[^ƂĒ`Ă܂̂łȗ鎖\łBȂ킿 }
{ FreeEllipse(Image, LT, RB); }
{ FreeEllipse(Image, LT, RB, ANoise); }
{ FreeEllipse(Image, LT, RB, ANoise, Scale); }
{ FreeEllipse(Image, LT, RB, ANoise, Scale, Fill); }
{ ̗lɋLq鎖\łB}

procedure FreeEllipse(var Image: TImage; // `
                      LT, RB: TPoint; // ȉ~̊Oڒ`̍ƉE̓_
                      ANoise: Integer = 5; // mCY̍őUl(sNZ)
                      Scale: Double = 0.03; // WƃmCY֐̃p[^̔{
                      Fill: Integer = 0  // ̓hԂw肷l
                      );
var
  a, b, s, t, ell: Double;
  x, y: Integer;
  aLT, aRB: TPoint;
  Col, PenCol, BrushCol: TColor;
begin
  if fStep < 1 then fStep := 1;
  if fStep > 4 then fStep := 4;

  s := (LT.X + RB.X) / 2; // ȉ~̒S_ x W
  t := (LT.Y + RB.Y) / 2; // ȉ~̒S_ y W
  a := Abs(RB.X - LT.X) / 2; // ȉ~̕ 1/2
  b := Abs(RB.Y - LT.Y) / 2; // ȉ~̍ 1/2

  if (Round(a) = 0) or (Round(b) = 0) then
    Exit;

  adjPoints(LT, RB, 0); // LT, RB 𐳋KB
  aLT := LT; aRB := RB; 
  adjPoints(aLT, aRB, ANoise); // aLT, aRB 𐳋KB

  PenCol := Image.Canvas.Pen.Color;
  BrushCol := Image.Canvas.Brush.Color;
  if (Fill and (fillBrush or fillCloud)) <> 0 then // hԂꍇ
  begin
    Col := PenCol;
    if NonExistColor(Image, Col, aLT, aRB) then
      Image.Canvas.Pen.Color := Col; // Col ͗̈ɑ݂ȂF
  end;

  if a >= b then // x ̒lωB
  begin
    x := LT.X;
    ell :=  t + b / a * Sqrt(a * a - (x - s) * (x - s));
    y := Round(ell + noise(Scale * x) * ANoise * 2 - ANoise);
    Image.Canvas.MoveTo(x, y);

    repeat
      x := x + fStep;
      ell := t + b / a * Sqrt(a * a - (x - s) * (x - s));
      y := Round(ell + noise(Scale * x) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
    until x >= RB.X;

    repeat
      x := x - fStep;
      ell := t - b / a * Sqrt(a * a - (x - s) * (x - s));
      y := Round(ell + noise(Scale * x) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
    until x <= LT.X;
  end
  else // y ̒lωB
  begin
    y := LT.Y;
    ell := s + a / b * Sqrt(b * b - (y - t) * (y - t));
    x := Round(ell + noise(Scale * y) * ANoise * 2 - ANoise);
    Image.Canvas.MoveTo(x, y);

    repeat
      y := y + fStep;
      ell := s + a / b * Sqrt(b * b - (y - t) * (y - t));
      x := Round(ell + noise(Scale * y) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
    until y >= RB.Y;

    repeat
      y := y - fStep;
      ell := s - a / b * Sqrt(b * b - (y - t) * (y - t));
      x := Round(ell + noise(Scale * y) * ANoise * 2 - ANoise);
      Image.Canvas.LineTo(x, y);
    until y <= LT.Y;
  end;

  if (Fill and (fillBrush or fillCloud)) <> 0 then // hԂꍇ
  begin
    x := Round(s); y := Round(t); // S_

    if (Fill and fillBrush) <> 0 then
    begin
      Image.Canvas.FloodFill(x, y, Col, fsBorder); //  BrushCol œhԂ
      if ((Fill and fillBorder) = 0) and (Col <> PenCol) then
      begin
        Image.Canvas.Pen.Color := PenCol;
        FreeEllipse(Image, LT, RB, ANoise, Scale, 0); // E`
      end;
      if ((Fill and fillBorder) <> 0) and (Col <> BrushCol) then
      begin
        Image.Canvas.Pen.Color := BrushCol;
        FreeEllipse(Image, LT, RB, ANoise, Scale, 0); // E`
      end;
    end
    else if (Fill and fillCloud) <> 0 then
    begin
      Image.Canvas.Brush.Color := Col;
      Image.Canvas.FloodFill(x, y, Col, fsBorder); //  Col œhԂ
      if MakeGradation(clWhite, clBlue, 128, gColors) = 128 then
        GridDraw(Image, aLT, aRB, 3, 128, 3, 0.5, 0, 0.03, gColors, Integer(Col));
      if (Fill and fillBorder) = 0 then
      begin
        Image.Canvas.Pen.Color := PenCol;
        FreeEllipse(Image, LT, RB, ANoise, Scale, 0); // E`
      end
      else
        ExceptColor(Image, Col, aLT, aRB); // Col 𑼂̐FɒuĖڂȂB
    end;
    Image.Canvas.Pen.Color := PenCol;
    Image.Canvas.Brush.Color := BrushCol;
  end;
end;

end.

